<?php
/**
 * Created by PhpStorm.
 * User: douglasribeiro
 * Date: 12/12/2014
 * Time: 07:25
 */

namespace Planejamento\Logic\PlanejamentoProducao;


use Setforms2\Runtime\Helper\Procedure;
use Setforms2\Runtime\Helper\Procedure\Param;

class PlanProducaoLogic {
    /** Função responsável pela execução da procedure de geração do planejamento
     */
    public static function ProcedureGeraPlanProducao(
        $operacao, $cdfilicent, $dtproducao, $nrconsplan, $nrplanprod,
        $dtinicard, $dtfincard, $tipoprat, $setor, $cdoperador, $nrorg
    )
    {
        try {
            $procedure = new Procedure('GERA_PLAN_PRODUCAO');
            $procedure->addParam(
                new Param (
                    'P_NRPLANPROD',
                    Param::PARAM_INPUT,
                    $nrplanprod,
                    Param::PARAM_TYPE_STR
                )
            );
            $procedure->addParam(
                new Param (
                    'P_OPERACAO',
                    Param::PARAM_INPUT,
                    $operacao,
                    Param::PARAM_TYPE_STR
                )
            );
            $procedure->addParam(
                new Param (
                    'P_CDFILCENT',
                    Param::PARAM_INPUT,
                    $cdfilicent,
                    Param::PARAM_TYPE_STR
                )
            );

            $procedure->addParam(
                new Param (
                    'P_DTPRODUCAO',
                    Param::PARAM_INPUT,
                    $dtproducao,
                    Param::PARAM_TYPE_STR
                )
            );

            $procedure->addParam(
                new Param (
                    'P_NRCONSPLAN',
                    Param::PARAM_INPUT,
                    $nrconsplan,
                    Param::PARAM_TYPE_STR
                )
            );

            $procedure->addParam(
                new Param (
                    'P_DTINICARD',
                    Param::PARAM_INPUT,
                    $dtinicard,
                    Param::PARAM_TYPE_STR
                )
            );

            $procedure->addParam(
                new Param (
                    'P_DTFINCARD',
                    Param::PARAM_INPUT,
                    $dtfincard,
                    Param::PARAM_TYPE_STR
                )
            );

            $procedure->addParam(
                new Param (
                    'P_TIPOPRAT',
                    Param::PARAM_INPUT,
                    $tipoprat,
                    Param::PARAM_TYPE_STR
                )
            );

            $procedure->addParam(
                new Param (
                    'P_SETOR',
                    Param::PARAM_INPUT,
                    $setor,
                    Param::PARAM_TYPE_STR
                )
            );

            $procedure->addParam(
                new Param (
                    'P_CDOPERADOR',
                    Param::PARAM_INPUT,
                    $cdoperador,
                    Param::PARAM_TYPE_STR
                )
            );

            $procedure->addParam(
                new Param (
                    'P_NRORG',
                    Param::PARAM_INPUT,
                    $nrorg,
                    Param::PARAM_TYPE_STR
                )
            );

            $procedure->addParam(
                new Param (
                    'P_RETORNO',
                    Param::PARAM_OUTPUT,
                    NULL,
                    Param::PARAM_TYPE_STR,
                    400
                )
            );

            return $procedure->call();

        } catch (\Exception $e) {
            throw $e;
        }
    }
} 