/*
 @C:\Web_635\Sql\End_Conv\Oracle\3970_PEDFUNO_BUSCA_DATA_ULTIMA_BAIXA.SQL

 Descrio:
 Funo para retornar o data da ltima baixa se todas as contas j tiverem sido baixadas

 Parmetros

 P_CDFILIAL    - Cdigo da filial
 P_NRLANCTONF  - Nmero do lanamento da nota

 raise_application_error(-20501, '' , True);
*/
create or replace FUNCTION BUSCA_DATA_ULTIMA_BAIXA(
   P_CDFILIAL     IN FILIAL.CDFILIAL%TYPE,
   P_NRLANCTONF   IN NOTAFISCAL.NRLANCTONF%TYPE) RETURN DATE IS

   V_DTVENBOLREC DATE;
   V_RETURN      DATE;
   V_CDFILIAL    VARCHAR2(04);
   V_NRLANBOLREC VARCHAR2(10);
   V_IDSTATBREC  VARCHAR2(01);
   V_COUNT       INTEGER;
BEGIN
   SELECT COUNT(1)
     INTO V_COUNT
     FROM CONTARECEBER CR
    WHERE CR.CDFILIAL =  P_CDFILIAL
      AND CR.NRLANCTONF = P_NRLANCTONF
      AND CR.IDSTATREC <> 'B';
      
   IF V_COUNT > 0 THEN
      RETURN(NULL);      
   ELSE
      
   SELECT MAX(CR.CDFILIBOLREC), MAX(CR.NRLANBOLREC)
     INTO V_CDFILIAL, V_NRLANBOLREC
     FROM NOTAFISCAL NF, CONTARECEBER CR
    WHERE NF.CDFILIAL =  P_CDFILIAL
      AND NF.NRLANCTONF = P_NRLANCTONF
      AND NF.CDFILIAL = CR.CDFILIAL
      AND NF.NRLANCTONF = CR.NRLANCTONF
      AND CR.DTATUAVENREC = (SELECT MAX(DTATUAVENREC)
                               FROM CONTARECEBER CR1
                              WHERE CR1.CDFILIAL = CR.CDFILIAL
                                AND CR1.NRLANCTONF = CR.NRLANCTONF);
     
      IF V_NRLANBOLREC IS NOT NULL THEN
            
         SELECT DTBAIXAREC
           INTO V_DTVENBOLREC 
           from(SELECT DTBAIXAREC
                  FROM BOLETRECEBER BR, BAIXARECEBIDA BA
                 WHERE BR.CDFILIAL = V_CDFILIAL
                   AND BR.NRLANBOLREC = V_NRLANBOLREC
                   AND BR.CDFILIBAIREC = BA.CDFILIAL
                   AND BR.NRBAIXAREC = BA.NRBAIXAREC
                   and DTBAIXAREC is not null
                 order by DTBAIXAREC desc
         ) where rownum = 1;             
            
         SELECT IDSTATBREC
           INTO V_IDSTATBREC 
           from(SELECT IDSTATBREC
                  FROM BOLETRECEBER BR, BAIXARECEBIDA BA
                 WHERE BR.CDFILIAL = V_CDFILIAL
                   AND BR.NRLANBOLREC = V_NRLANBOLREC
                   AND BR.CDFILIBAIREC = BA.CDFILIAL
                   AND BR.NRBAIXAREC = BA.NRBAIXAREC
                   and IDSTATBREC is not null
                 order by IDSTATBREC desc
         ) where rownum = 1;            
            
      END IF;
      
      
      IF (V_IDSTATBREC <> 'B') THEN
         V_RETURN := NULL;    
      ELSE               
         V_RETURN := V_DTVENBOLREC;    
      END IF;
   END IF;
   RETURN(V_RETURN);  
END;
/
-- VERSAO --
BEGIN ATUVEROBJ('BUSCA_DATA_ULTIMA_BAIXA','6.49.025'); END;
/
